## cduce 0.6.0

=== Makefile ===
include Makefile.distrib

# For development

pull: tools/pull.$(EXTENSION)
	$(LINK) -o $@ $^

PREPRO = camlp4o -I `ocamlfind query ulex` pa_ulex.cma pr_o.cmo $(SYNTAX) -sep "\n"

profile: misc/q_symbol.cmo
	rm -Rf prepro
	mkdir prepro
	for i in $(DIRS); do \
	mkdir prepro/$$i; \
	for j in $$i/*.ml $$i/*.mli; do \
	if [ -f "$$j" ]; then \
	 echo $$j; \
	 $(PREPRO) $$j -o prepro/$$j; \
	fi; \
	done; \
	done
	cp Makefile.distrib Makefile Makefile.conf prepro/
	(cd prepro;  \
	touch depend; \
	$(MAKE) compute_depend PROFILE=true SYNTAX_PARSER= ; \
	$(MAKE) cduce PROFILE=true SYNTAX_PARSER= NATIVE=false)


SCRIPT =
INCLUDES_DEB = $(INCLUDES) $(shell ocamlfind query -i-format -recursive $(PACKAGES))
DEBUGGER = ocamldebug
debug:
	ledit $(DEBUGGER) $(INCLUDES_DEB) ./cduce $(SCRIPT)

# Packaging

DISTRIB = $(DIRS) web cduce.spec depend INSTALL INSTALL.WIN32 CHANGES \
 LICENSE README AUTHORS Makefile.conf.template configure configure.ml doc \
 META.in cduce_mktop VERSION PLIST.godi Makefile.macosx tools/make-package-macosx

DISTRIB_DOC = doc.xml memento.xml tutorial.xml manual.xml tutorial manual \
 xhtml.cd xhtml-categ.cd xhtml-strict.cd site.cd siteTypes.cd

PACKAGE = cduce-$(VERSION)
.PHONY: package
package: clean
	rm -Rf $(PACKAGE)
	mkdir $(PACKAGE)
	cp -R $(DISTRIB) $(PACKAGE)/
	cp Makefile.distrib $(PACKAGE)/Makefile
	mkdir $(PACKAGE)/tools
	cp tools/dtd2cduce.ml  $(PACKAGE)/tools/
	(cd $(PACKAGE); \
	rm -f types/IDEAS; \
        for F in $(DEPEND); do headache -h ../header $$F; done)
	tar czf $(PACKAGE).tar.gz --exclude .svn --exclude ".#*" $(PACKAGE)
	rm -Rf $(PACKAGE)

OCAML_STDLIBDIR := $(shell ocamlc -where)
.PHONY: .ocamlinit
.ocamlinit:
	echo '(* AUTOMATICALLY GENERATED by Makefile: DO NOT EDIT! *)' > $@
	echo '#load "$(OCAML_STDLIBDIR)/pcre/pcre.cma";;' >> $@
	echo '#load "$(OCAML_STDLIBDIR)/unix.cma";;' >> $@
	echo '#load "$(OCAML_STDLIBDIR)/netstring/netstring.cma";;' >> $@
# 	echo '#load "$(OCAML_STDLIBDIR)/netstring/netstring_top.cmo";;' >> $@
	echo '#load "$(OCAML_STDLIBDIR)/pxp-engine/pxp_engine.cma";;' >> $@
# 	echo '#load "$(OCAML_STDLIBDIR)/pxp-engine/pxp_top.cmo";;' *)' >> $@
	echo '#load "$(OCAML_STDLIBDIR)/pxp-lex-iso88591/pxp_lex_iso88591.cma";;' >> $@
	echo '#load "$(OCAML_STDLIBDIR)/pxp-lex-iso88591/pxp_lex_link_iso88591.cmo";;' >> $@
	echo '#load "$(OCAML_STDLIBDIR)/ulex/ulexing.cma";;' >> $@
	echo '#load "$(OCAML_STDLIBDIR)/nums.cma";;' >> $@
# 	echo '#load "$(OCAML_STDLIBDIR)/num_top.cma";;' >> $@
	echo '#load "$(OCAML_STDLIBDIR)/cgi/cgi.cma";;' >> $@
	for o in $(VALIDATE_OBJECTS); do echo "prerr_endline \"Loading $$o ...\";;" >> $@; echo "#load \"$$o\";;" >> $@; done
	for d in $(DIRS); do echo "#directory \"$$d\";;" >> $@; done
	for p in pcre netstring pxp-engine ulex cgi; do echo "#directory \"`$(OCAMLFIND) query $$p`\";;" >> $@; done
	echo "prerr_endline \"All done!\"" >> $@
	echo '(* vim: set ft=ocaml: *)' >> $@

CVS_DISTRIB = web CHANGES LICENSE README AUTHORS cduce dtd2cduce
CVS_DOC = doc/cdo2ml.1 doc/cduce.1 doc/cduce_mktop.1  doc/cduce_validate.1 doc/dtd2cduce.1 doc/fomanual/tutorial.pdf doc/fomanual/manual.pdf
cvs_snapshot_bin: clean
	if [[ `uname` != Linux ]]; then echo "Not a Linux box!"; exit 2; fi
	$(MAKE) cduce dtd2cduce NATIVE=true EXTRA_LINK_OPTS="-ccopt -static" VERSION=cvs`date +%Y%m%d`
	rm -Rf cduce-cvs
	mkdir cduce-cvs
	mkdir cduce-cvs/doc
	cp -R $(CVS_DISTRIB) cduce-cvs
	cp $(CVS_DOC) cduce-cvs/doc
	cp Makefile.binary cduce-cvs/Makefile
	tar czf cduce-cvs-linux-static.tar.gz --exclude CVS cduce-cvs
	rm -Rf cduce-cvs
	scp cduce-cvs-linux-static.tar.gz cduce@di.ens.fr:public_html/download

.PHONY: test
test: all
	@tests/test.sh

extendedtest: all
	@tests/test.sh -e

############ CGI DEMO ###################

cgi: webiface evaluator

driver/examples.ml: cduce web/xhtml.cdo web/examples/build.cd web/examples/examples.xml
	(cd web/examples; ../../cduce build.cd -I .. --arg examples.xml)

WEBIFACE  = $(OBJECTS) driver/examples.cmo driver/webiface.cmo
EVALUATOR = $(OBJECTS) driver/evaluator.cmo

webiface: $(WEBIFACE:.cmo=.$(EXTENSION))
	@echo "Build $@"
	$(HIDE)$(LINK) -verbose $(INCLUDES) -o $@ $^ $(EXTRA_OPTS_WEBIFACE)

evaluator: $(EVALUATOR:.cmo=.$(EXTENSION))
	@echo "Build $@"
	$(HIDE)$(LINK) -verbose $(INCLUDES) -o $@ $^ $(EXTRA_OPTS_WEBIFACE)

# webiface can be made static to be able to move it more easily
# (to compile it on a machine which is not the web server)
# Seems to be some problems with statically linking curl
# EXTRA_OPTS_WEBIFACE += -ccopt -static

=== benchmarks/Makefile ===
split:
	ocaml unix.cma bench.ml split 0,10,50,100,500,1000 \
	split*.cd split*.xsl \
	| tee split.results

addrbook:
	ocaml unix.cma bench.ml addrbook 0,1000,5000,10000,50000,100000 \
	addrbook*.cd addrbook*.xsl \
	| tee addrbook.results
clean:
	rm -f split.*.xml addrbook.*.xml
	rm -f *~
	rm -f *.results

=== doc/Makefile ===
# MAN = cduce.1 dtd2cduce.1 cduce_validate.1 cdo2ml.1 cduce_mktop.1
INSTALL_MAN = cduce.1 cduce_mktop.1 dtd2cduce.1
MAN = $(INSTALL_MAN)

all: $(MAN)

.SUFFIXES: .1 .docbook

.docbook.1:
	docbook-to-man $< > $@

install:
	@echo "Install man pages"
	$(HIDE)$(INSTALL) -m644 $(INSTALL_MAN) $(MANDIR)/man1/

=== ocamliface/Makefile ===
# This Makefile generates caml_cduce.cmo/.cmx
# It must be called with an OCAML_SRC argument pointing to the root
# of an OCaml source tree.
include ../Makefile.conf

all: caml_cduce.cmo caml_cduce.cmx

STDLIB=$(shell ocamlc -where)


ifeq ($(FORPACK),true)
  FORPACKOPT1=-for-pack Cduce_lib.Caml_cduce
  FORPACKOPT2=-for-pack Cduce_lib
else
  FORPACKOPT1=
  FORPACKOPT2=
endif

ocaml_files:
	mkdir ocaml_files
	$(HIDE)cp $(patsubst %,$(OCAML_SRC)/%, $(COPY_FILES)) ocaml_files/
	cp location.ml ocaml_files/location.ml
	cp ocaml_files/asttypes.mli ocaml_files/asttypes.ml
	sed s=STDLIB=$(STDLIB)= config.ml > ocaml_files/config.ml
	grep cmi_magic $(OCAML_SRC)/utils/config.mlp | head -1 >> ocaml_files/config.ml

caml_cduce.cmo: ocaml_files
	@echo "Build $@"
	(cd ocaml_files; \
	ocamlc $(FORPACKOPT1) -c $(COMPILE_FILES);\
	ocamlc $(FORPACKOPT2) -pack -o $@ $(OBJECTS); \
	cp caml_cduce.cmo caml_cduce.cmi ..)

caml_cduce.cmx: ocaml_files
	@echo "Build $@"
	(cd ocaml_files; ocamlopt $(FORPACKOPT1) -c $(COMPILE_FILES);\
	ocamlopt $(FORPACKOPT2) -pack -o $@ $(XOBJECTS); \
	cp caml_cduce.cmx caml_cduce.o caml_cduce.cmi ..)

clean:
	rm -Rf ocaml_files *~ *.cm*

COPY_FILES=\
  typing/annot.mli \
  utils/misc.ml utils/tbl.ml \
  utils/consistbl.ml utils/warnings.ml utils/terminfo.ml utils/clflags.ml \
  parsing/asttypes.mli parsing/location.mli \
  parsing/longident.ml \
  typing/outcometree.mli \
  typing/ident.ml typing/path.ml \
  typing/primitive.ml typing/types.ml \
  typing/btype.ml typing/oprint.ml \
  typing/subst.ml typing/predef.ml \
  typing/datarepr.ml typing/env.ml \
  typing/ctype.ml typing/ctype.mli typing/printtyp.ml typing/cmi_format.mli typing/cmi_format.ml

COMPILE_FILES=\
  warnings.ml location.mli asttypes.mli outcometree.mli annot.mli asttypes.ml \
  config.ml misc.ml tbl.ml \
  clflags.ml consistbl.ml terminfo.ml \
  location.ml longident.ml \
  ident.ml path.ml \
  primitive.ml types.ml \
  btype.ml oprint.ml \
  subst.ml predef.ml \
  datarepr.ml cmi_format.mli cmi_format.ml env.ml ctype.mli ctype.ml printtyp.ml

COMPILE_FILES_ML=$(filter %.ml,$(COMPILE_FILES))
OBJECTS=$(COMPILE_FILES_ML:.ml=.cmo)
XOBJECTS=$(COMPILE_FILES_ML:.ml=.cmx)

=== debian/changelog ===
cduce (0.6.0-1) unstable; urgency=medium

  * New upstream release (Closes: #731818)
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Mar 2014 09:49:39 +0100

=== debian/control ===
Source: cduce
Section: interpreters
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>,
 Pietro Abate <pietro.abate@pps.jussieu.fr>
Build-Depends:
 debhelper (>= 7.2.11~),
 dh-ocaml (>= 0.9~),
 ocaml-nox (>= 3.11.1-3~),
 camlp4-extra,
 ocaml-source (>= 3.11.0),
 libpcre-ocaml-dev (>= 6.0.1-2~),
 libocamlnet-ocaml-dev (>= 2.2.9-7~),
 libexpat-ocaml-dev (>= 0.9.1+debian1-6~),
 libcurl-ocaml-dev (>= 0.5.1-2~),
 ocaml-ulex (>= 1.1-2~),
 chrpath,
 bzip2
Standards-Version: 3.9.2
Homepage: http://www.cduce.org
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/cduce.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/cduce.git

Package: cduce
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: programming language adapted to the manipulation of XML data
 CDuce is a modern programming language adapted to the manipulation of
 XML documents.
 .
 Some of CDuce's peculiar features:
  - XML objects can be manipulated as first-class citizen values:
    elements, sequences, tags, characters and strings, attribute sets;
    sequences of XML elements can be specified by regular expressions,
    which also apply to characters strings;
  - functions themselves are first-class values, they can be
    manipulated, stored in data structure, returned by a function,...;
  - a powerful pattern matching operation can perform complex
    extractions from sequences of XML elements;
  - a rich type algebra, with recursive types and arbitrary boolean
    combinations (union, intersection, complement) allows precise
    definitions of data structures and XML types; general purpose
    types and types constructors are taken seriously (products,
    extensible records, arbitrary precision integers with interval
    constraints, Unicode characters);
  - polymorphism through a natural notion of subtyping, and overloaded
    functions with dynamic dispatch; - an highly-effective type-driven
    compilation schema.
 .
 CDuce is fast, functional, type-safe, and conforms to basic
 standards: Unicode, XML, DTD, Namespaces are fully supported, partial
 support of XML Schema validation is in alpha testing (and
 undocumented) while queries are being implemented.

=== debian/rules ===
#!/usr/bin/make -f
PACKAGE = cduce

include /usr/share/ocaml/ocamlinit.mk
ifeq ($(OCAML_NATDYNLINK),yes)
  MAKE_OPTS := "NATIVE=true"
else
  MAKE_OPTS := "NATIVE=false"
endif

LIBDIR=$(CURDIR)/debian/cduce/$(OCAML_STDLIB_DIR)
DOCDIR=$(CURDIR)/debian/cduce/usr/share/doc/cduce/html
BINDIR=$(CURDIR)/debian/cduce/usr/bin
MANDIR=$(CURDIR)/debian/cduce/usr/share/doc/man

CONFIGURE_OPTS := --prefix=/usr \
  --mliface=debian/ocaml-$(OCAML_ABI) \
  --with-curl \
  --without-netclient \
  --with-expat \
  --without-pxp

%:
	dh --with ocaml $@

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	tar -C debian -xf /usr/src/ocaml-source-$(OCAML_ABI).tar
	tar -C debian -xjf debian/ocaml-$(OCAML_ABI)/ocaml_$(OCAML_ABI).orig.tar.bz2
	./configure  $(CONFIGURE_OPTS)

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(MAKE_OPTS) all doc

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	touch Makefile.conf
	[ ! -f Makefile ] || $(MAKE) $(MAKE_OPTS) clean
	-$(RM) Makefile.conf
	-$(RM) -rf debian/ocaml-$(OCAML_ABI)/

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) $(MAKE_OPTS) DOCDIR=$(DOCDIR) BINDIR=$(BINDIR) MANDIR=$(MANDIR) OCAMLFIND_DESTDIR=$(LIBDIR) OCAMLFIND_LDCONF=ignore install

	# Remove the wrong RPATH
	chrpath -d $(BINDIR)/cduce

	# CDuce Makefile installs all the documentation in DOCDIR, including
	# README, LICENSE, and so on. We don't want these. Let's hack.
	find $(DOCDIR) -maxdepth 1 -not -name "*.html" -not -name "img" -exec rm {} \;
	-$(RM) -rf $(MANDIR)

.PHONY: override_dh_ocaml
override_dh_ocaml:
	dh_ocaml --runtime-map cduce

# Tests suppose the OCaml library is installed
.PHONY: override_dh_auto_test
override_dh_auto_test:

=== debian/watch ===
version=3
http://www.cduce.org/download.html download/cduce-([0-9\.]*)\.tar\.gz
